---
tertiary:
  - name: "Performance improvements"
    available_in: [ core, premium, ultimate ]
    performance_improvements_url: 'https://gitlab.com/gitlab-org/gitlab/-/issues?sort=created_date&state=closed&label_name[]=performance&milestone_title=14.5'
    reporter: multiple
    description: |
      In every release, we continue to make great strides improving GitLab's performance. We're committed to making every GitLab instance faster. This includes GitLab.com, an instance with over 1 million registered users!

      In GitLab 14.5, we're shipping performance improvements for issues, projects, milestones, and much more! Some improvements in GitLab 14.5 are:

      - [Dependency Proxy workhorse migration for image manifests](https://gitlab.com/gitlab-org/gitlab/-/issues/335560).
      - [Add `read_at` data to the dependency proxy](https://gitlab.com/gitlab-org/gitlab/-/issues/341536).
      - [Convert Package List page to use GraphQL](https://gitlab.com/gitlab-org/gitlab/-/issues/330846).
      - [Cache database repository objects for API requests](https://gitlab.com/gitlab-org/container-registry/-/issues/452).
      - [Significant no-op increments in PK sequences for `top_level_namespaces` and `repositories` tables](https://gitlab.com/gitlab-org/container-registry/-/issues/483).
      - [The setting **Prevent sharing a project within a group with other groups** times out for large group hierarchies](https://gitlab.com/gitlab-org/gitlab/-/issues/336468).
      - [Allow Kubesec SAST analyzer to Analyze manifests concurrently](https://gitlab.com/gitlab-org/security-products/analyzers/kubesec/-/merge_requests/55).
      - [Fix N+1 query for `VulnerabilityType`](https://gitlab.com/gitlab-org/gitlab/-/issues/292993).
      - [Make the environments picker dropdown not load all environments at once](https://gitlab.com/gitlab-org/gitlab/-/issues/340982).
      - [Optimizations for reading Git objects in Gitaly](https://gitlab.com/groups/gitlab-org/-/epics/6773):
          - [Optimize parsing of Git objects to consume less memory](https://gitlab.com/gitlab-org/gitaly/-/issues/3783).
          - [Reduce steps required to read Git objects in many Gitaly RPCs](https://gitlab.com/gitlab-org/gitaly/-/merge_requests/3969).
          - [Introduce request queues to batch reading of objects](https://gitlab.com/gitlab-org/gitaly/-/merge_requests/4032).
      - [`ConnectionRedaction` times out on boards with label lists when grouped by epic](https://gitlab.com/gitlab-org/gitlab/-/issues/331723).
      - [Negated filtering with non-existing label produces very slow query plans](https://gitlab.com/gitlab-org/gitlab/-/issues/344074).
